Attribute VB_Name = "ResChange"
'ResChanger 2.0
'Copyright 2005 Ryan Thoryk
'http://www.tliquest.net/
'Contact - ryan@tliquest.net

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public CurrentResX As Long
Public CurrentResY As Long
Public CurrentResC As Integer
Public CurrentResR As Long

Public XValue As Long
Public CValue As Integer
Public RValue As Long

Public Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Private Declare Function ChangeDisplaySettingsEx Lib "user32" Alias "ChangeDisplaySettingsExA" (lpszDeviceName As Any, lpDevMode As Any, ByVal hWnd As Long, ByVal dwFlags As Long, lParam As Any) As Long
Public Declare Function GetTickCount& Lib "kernel32" ()

Public Const CCDEVICENAME = 32
Public Const CCFORMNAME = 32
Public Const DM_PELSWIDTH = &H80000
Public Const DM_PELSHEIGHT = &H100000
Public Const DM_DISPLAYFREQUENCY = &H400000
Public Const DM_BITSPERPIXEL = &H40000
Public Const CDS_UPDATEREGISTRY = &H1
Public Const CDS_TEST = &H4
Public Const DISP_CHANGE_SUCCESSFUL = 0
Public Const DISP_CHANGE_RESTART = 1
Public Const ENUM_CURRENT_SETTINGS = &HFFFF - 1

Public Type DEVMODE
    dmDeviceName As String * CCDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer 'Color Quality (can be 8, 16, 24, 32 or even 4)
    dmPelsWidth As Long 'Display Width in pixels
    dmPelsHeight As Long 'Display height in pixels
    dmDisplayFlags As Long
    dmDisplayFrequency As Long 'Display frequency
    dmICMMethod As Long 'NT 4.0
    dmICMIntent As Long 'NT 4.0
    dmMediaType As Long 'NT 4.0
    dmDitherType As Long 'NT 4.0
    dmReserved1 As Long 'NT 4.0
    dmReserved2 As Long 'NT 4.0
    dmPanningWidth As Long 'Win2000
    dmPanningHeight As Long 'Win2000
End Type

Public DevM As DEVMODE
Option Explicit

Public Function ChangeRes(ScreenX As Long, ScreenY As Long, ScreenColor As Integer, ScreenFreq As Long, SaveToRegistry As Boolean) As Integer
    'MsgBox (Str$(ScreenX) + " " + Str$(ScreenY) + " " + Str$(ScreenColor) + " " + Str$(ScreenFreq))
    Dim Result As Integer
    
    DevM.dmPelsWidth = ScreenX          'Screen width
    DevM.dmPelsHeight = ScreenY         'Screen height
    DevM.dmBitsPerPel = ScreenColor       'Screen color quality
    DevM.dmDisplayFrequency = ScreenFreq   'Screen display frequency
    
    DevM.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPIXEL Or DM_DISPLAYFREQUENCY

    If SaveToRegistry = False Then Result = ChangeDisplaySettingsEx(ByVal 0&, DevM, ByVal 0&, CDS_TEST, ByVal 0&)
    If SaveToRegistry = True Then Result = ChangeDisplaySettingsEx(ByVal 0&, DevM, ByVal 0&, CDS_UPDATEREGISTRY, ByVal 0&)
End Function

Public Sub GetCurrentRes()
Call EnumDisplaySettings(0&, ENUM_CURRENT_SETTINGS, DevM)
CurrentResX = DevM.dmPelsWidth
CurrentResY = DevM.dmPelsHeight
CurrentResC = DevM.dmBitsPerPel
CurrentResR = DevM.dmDisplayFrequency
Call SelectRes(True, DevM, False)
End Sub

Public Sub GetResolutions()
Dim nr As Long, ret As Long
Dim devMs() As DEVMODE
ReDim devMs(0)
devMs(0).dmSize = LenB(devMs(0))
nr = 0
ret = EnumDisplaySettings(0&, nr, devMs(nr))
Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim l As Integer
Entries.List1.Clear

Do
    Entries.List1.AddItem devMs(nr).dmPelsWidth & " x " & devMs(nr).dmPelsHeight & " x " & devMs(nr).dmBitsPerPel & " @ " & devMs(nr).dmDisplayFrequency & "Hz"
    
    If CheckRes(devMs(nr)) = True Then
        Call SelectRes(False, devMs(nr), False)
    Else
        Call SelectRes(False, devMs(nr), True)
    End If
    
    nr = nr + 1
    ReDim Preserve devMs(nr)
    ret = EnumDisplaySettings(0&, nr, devMs(nr))
Loop Until ret = 0

End Sub

Public Sub SelectRes(SelectOnly As Boolean, ObjectID As DEVMODE, ResOnly As Boolean)
Dim X As Long
Dim C As Integer
Dim R As Long

If ObjectID.dmPelsWidth = 2048 And ObjectID.dmPelsHeight = 1536 Then X = 0
If ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 1200 Then X = 1
If ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 1024 Then X = 2
If ObjectID.dmPelsWidth = 1152 And ObjectID.dmPelsHeight = 864 Then X = 3
If ObjectID.dmPelsWidth = 1024 And ObjectID.dmPelsHeight = 768 Then X = 4
If ObjectID.dmPelsWidth = 800 And ObjectID.dmPelsHeight = 600 Then X = 5
If ObjectID.dmPelsWidth = 640 And ObjectID.dmPelsHeight = 480 Then X = 6
If ObjectID.dmPelsWidth = 320 And ObjectID.dmPelsHeight = 240 Then X = 7
If ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1440 Then X = 8
If ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1200 Then X = 9
If ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1080 Then X = 10
If ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 1024 Then X = 11
If ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 900 Then X = 12
If ObjectID.dmPelsWidth = 1360 And ObjectID.dmPelsHeight = 768 Then X = 13
If ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 960 Then X = 14
If ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 800 Then X = 15
If ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 768 Then X = 16
If ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 720 Then X = 17
If ObjectID.dmPelsWidth = 960 And ObjectID.dmPelsHeight = 600 Then X = 18
If ObjectID.dmPelsWidth = 848 And ObjectID.dmPelsHeight = 480 Then X = 19
If ObjectID.dmPelsWidth = 720 And ObjectID.dmPelsHeight = 576 Then X = 20
If ObjectID.dmPelsWidth = 720 And ObjectID.dmPelsHeight = 480 Then X = 21
If ObjectID.dmPelsWidth = 640 And ObjectID.dmPelsHeight = 400 Then X = 22
If ObjectID.dmPelsWidth = 512 And ObjectID.dmPelsHeight = 384 Then X = 23
If ObjectID.dmPelsWidth = 480 And ObjectID.dmPelsHeight = 360 Then X = 24
If ObjectID.dmPelsWidth = 400 And ObjectID.dmPelsHeight = 300 Then X = 25
If ObjectID.dmPelsWidth = 320 And ObjectID.dmPelsHeight = 200 Then X = 26
If ObjectID.dmBitsPerPel = 1 Then C = 0
If ObjectID.dmBitsPerPel = 4 Then C = 1
If ObjectID.dmBitsPerPel = 8 Then C = 2
If ObjectID.dmBitsPerPel = 15 Then C = 3
If ObjectID.dmBitsPerPel = 16 Then C = 4
If ObjectID.dmBitsPerPel = 24 Then C = 5
If ObjectID.dmBitsPerPel = 32 Then C = 6
If ObjectID.dmDisplayFrequency = 60 Then R = 0
If ObjectID.dmDisplayFrequency = 70 Then R = 1
If ObjectID.dmDisplayFrequency = 72 Then R = 2
If ObjectID.dmDisplayFrequency = 75 Then R = 3
If ObjectID.dmDisplayFrequency = 85 Then R = 4
If ObjectID.dmDisplayFrequency = 100 Then R = 5
If ObjectID.dmDisplayFrequency = 120 Then R = 6
If ObjectID.dmDisplayFrequency = 140 Then R = 7
If ObjectID.dmDisplayFrequency = 144 Then R = 8
If ObjectID.dmDisplayFrequency = 150 Then R = 9
If ObjectID.dmDisplayFrequency = 170 Then R = 10
If ObjectID.dmDisplayFrequency = 200 Then R = 11
If ObjectID.dmDisplayFrequency = 240 Then R = 12
If ObjectID.dmDisplayFrequency = 56 Then R = 13

If SelectOnly = True Then
    Main.X(X).Value = True
    Main.C(C).Value = True
    Main.R(R).Value = True
    XValue = X
    CValue = C
    RValue = R
Else
    Main.X(X).Enabled = True
    If ResOnly = True Then Exit Sub
    Main.C(C).Enabled = True
    Main.R(R).Enabled = True
End If
End Sub

Private Function CheckRes(ObjectID As DEVMODE) As Boolean
CheckRes = False
If XValue = 0 And ObjectID.dmPelsWidth = 2048 And ObjectID.dmPelsHeight = 1536 Then CheckRes = True
If XValue = 1 And ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 1200 Then CheckRes = True
If XValue = 2 And ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 1024 Then CheckRes = True
If XValue = 3 And ObjectID.dmPelsWidth = 1152 And ObjectID.dmPelsHeight = 864 Then CheckRes = True
If XValue = 4 And ObjectID.dmPelsWidth = 1024 And ObjectID.dmPelsHeight = 768 Then CheckRes = True
If XValue = 5 And ObjectID.dmPelsWidth = 800 And ObjectID.dmPelsHeight = 600 Then CheckRes = True
If XValue = 6 And ObjectID.dmPelsWidth = 640 And ObjectID.dmPelsHeight = 480 Then CheckRes = True
If XValue = 7 And ObjectID.dmPelsWidth = 320 And ObjectID.dmPelsHeight = 240 Then CheckRes = True
If XValue = 8 And ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1440 Then CheckRes = True
If XValue = 9 And ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1200 Then CheckRes = True
If XValue = 10 And ObjectID.dmPelsWidth = 1920 And ObjectID.dmPelsHeight = 1080 Then CheckRes = True
If XValue = 11 And ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 1024 Then CheckRes = True
If XValue = 12 And ObjectID.dmPelsWidth = 1600 And ObjectID.dmPelsHeight = 900 Then CheckRes = True
If XValue = 13 And ObjectID.dmPelsWidth = 1360 And ObjectID.dmPelsHeight = 768 Then CheckRes = True
If XValue = 14 And ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 960 Then CheckRes = True
If XValue = 15 And ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 800 Then CheckRes = True
If XValue = 16 And ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 768 Then CheckRes = True
If XValue = 17 And ObjectID.dmPelsWidth = 1280 And ObjectID.dmPelsHeight = 720 Then CheckRes = True
If XValue = 18 And ObjectID.dmPelsWidth = 960 And ObjectID.dmPelsHeight = 600 Then CheckRes = True
If XValue = 19 And ObjectID.dmPelsWidth = 848 And ObjectID.dmPelsHeight = 480 Then CheckRes = True
If XValue = 20 And ObjectID.dmPelsWidth = 720 And ObjectID.dmPelsHeight = 576 Then CheckRes = True
If XValue = 21 And ObjectID.dmPelsWidth = 720 And ObjectID.dmPelsHeight = 480 Then CheckRes = True
If XValue = 22 And ObjectID.dmPelsWidth = 640 And ObjectID.dmPelsHeight = 400 Then CheckRes = True
If XValue = 23 And ObjectID.dmPelsWidth = 512 And ObjectID.dmPelsHeight = 384 Then CheckRes = True
If XValue = 24 And ObjectID.dmPelsWidth = 480 And ObjectID.dmPelsHeight = 360 Then CheckRes = True
If XValue = 25 And ObjectID.dmPelsWidth = 400 And ObjectID.dmPelsHeight = 300 Then CheckRes = True
If XValue = 26 And ObjectID.dmPelsWidth = 320 And ObjectID.dmPelsHeight = 200 Then CheckRes = True
End Function

Public Function ChooseRes() As Integer
Dim X As Long
Dim Y As Long
Dim C As Integer
Dim R As Long

If XValue = 0 Then X = 2048: Y = 1536
If XValue = 1 Then X = 1600: Y = 1200
If XValue = 2 Then X = 1280: Y = 1024
If XValue = 3 Then X = 1152: Y = 864
If XValue = 4 Then X = 1024: Y = 768
If XValue = 5 Then X = 800: Y = 600
If XValue = 6 Then X = 640: Y = 480
If XValue = 7 Then X = 320: Y = 240
If XValue = 8 Then X = 1920: Y = 1440
If XValue = 9 Then X = 1920: Y = 1200
If XValue = 10 Then X = 1920: Y = 1080
If XValue = 11 Then X = 1600: Y = 1024
If XValue = 12 Then X = 1600: Y = 900
If XValue = 13 Then X = 1360: Y = 768
If XValue = 14 Then X = 1280: Y = 960
If XValue = 15 Then X = 1280: Y = 800
If XValue = 16 Then X = 1280: Y = 768
If XValue = 17 Then X = 1280: Y = 720
If XValue = 18 Then X = 960: Y = 600
If XValue = 19 Then X = 848: Y = 480
If XValue = 20 Then X = 720: Y = 576
If XValue = 21 Then X = 720: Y = 480
If XValue = 22 Then X = 640: Y = 400
If XValue = 23 Then X = 512: Y = 384
If XValue = 24 Then X = 480: Y = 360
If XValue = 25 Then X = 400: Y = 300
If XValue = 26 Then X = 320: Y = 200
If CValue = 0 Then C = 1
If CValue = 1 Then C = 4
If CValue = 2 Then C = 8
If CValue = 3 Then C = 15
If CValue = 4 Then C = 16
If CValue = 5 Then C = 24
If CValue = 6 Then C = 32
If RValue = 0 Then R = 60
If RValue = 1 Then R = 70
If RValue = 2 Then R = 72
If RValue = 3 Then R = 75
If RValue = 4 Then R = 85
If RValue = 5 Then R = 100
If RValue = 6 Then R = 120
If RValue = 7 Then R = 140
If RValue = 8 Then R = 144
If RValue = 9 Then R = 150
If RValue = 10 Then R = 170
If RValue = 11 Then R = 200
If RValue = 12 Then R = 240
If RValue = 13 Then R = 56
ChooseRes = ChangeRes(X, Y, C, R, False)
End Function

